#define STRICT
#include <windows.h>
#include <windowsx.h>
#pragma hdrstop

#include <stdio.h>
#include <commctrl.h>

#include "WebMask.h"
#include "Dialog.h"
#include "Resource.h"

static DialogPage::HelpTopics helpIds[]={
   {ID_CB_GOPHER, "auto.gopherimages"},
   {ID_CB_LOCAL,  "auto.localcopy"},
   {ID_EB_LOCAL,  "auto.localcopy"},
   {ID_CB_NOCACHE,"auto.nocache"}
};

class AdvancedDialogPage:public DialogPage{
public:
   AdvancedDialogPage():DialogPage(DIALOG_ADVANCED,ICON_ADVANCED,::helpIds,
      sizeof(::helpIds)/sizeof(*::helpIds),"advanced","advanced.html"){}
   virtual void save();
   virtual void load();
   virtual void enable(HWND);
   virtual BOOL init(HWND,HWND,LPARAM);
//   virtual void exit();
   virtual void command(HWND hwnd,int id,HWND hwndCtl,UINT notify);
   virtual int apply(HWND hwnd,int,LPNMHDR pnmhdr);
};



void AdvancedDialogPage::load(){
   HKEY hkey;
   if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\PseudoFoo\\WebMask",0,
                   KEY_READ,&hkey)!=ERROR_SUCCESS)
      hkey=NULL;
   LoadRegNumDef   (hkey,"gopherImg"  ,gopherImages ,FALSE                  );
   LoadRegNumDef   (hkey,"useLocal"   ,useLocal     ,FALSE                  );
   LoadRegStringDef(hkey,"localPath"  ,localPath,256,""                     );
   LoadRegNumDef   (hkey,"nocache"    ,nocache      ,FALSE                  );

   if(hkey) RegCloseKey(hkey);
}

void AdvancedDialogPage::save(){
   HKEY hkey;
   if(RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\PseudoFoo\\WebMask",0,
                     NULL,REG_OPTION_NON_VOLATILE,
                     KEY_READ|KEY_WRITE,NULL,&hkey,NULL)==ERROR_SUCCESS){
      SaveRegNum   (hkey,"gopherImg"  ,gopherImages);
      SaveRegNum   (hkey,"useLocal"   ,useLocal    );
      SaveRegString(hkey,"localPath"  ,localPath   );
      SaveRegNum   (hkey,"nocache"    ,nocache     );

      RegCloseKey(hkey);
   }
}

void AdvancedDialogPage::enable(HWND hwnd){
   BOOL loc=Button_GetCheck(GetDlgItem(hwnd,ID_CB_LOCAL));
   Edit_Enable(  GetDlgItem(hwnd,ID_EB_LOCAL      ),loc);
}

BOOL AdvancedDialogPage::init(HWND hwnd,HWND,LPARAM){
   Button_SetCheck(GetDlgItem(hwnd,ID_CB_GOPHER),gopherImages);

   Button_SetCheck(GetDlgItem(hwnd,ID_CB_LOCAL),useLocal);

   Edit_LimitText(GetDlgItem(hwnd,ID_EB_LOCAL),255);
   Edit_SetText  (GetDlgItem(hwnd,ID_EB_LOCAL),localPath);

   Button_SetCheck(GetDlgItem(hwnd,ID_CB_NOCACHE),nocache);

   enable(hwnd);
   return(TRUE);
}

void AdvancedDialogPage::command(HWND hwnd,int id,HWND hwndCtl,UINT notify){
   switch(id){
      case ID_EB_VIA:
      case ID_EB_LOCAL:
         if(notify==EN_CHANGE){
            PropSheet_Changed(hPropWnd,hwnd);
         }
         break;
      default:
         DialogPage::command(hwnd,id,hwndCtl,notify);
   }

   enable(hwnd);
}

int AdvancedDialogPage::apply(HWND hwnd,int,LPNMHDR){
   gopherImages=Button_GetCheck(GetDlgItem(hwnd,ID_CB_GOPHER));

   useLocal=Button_GetCheck(GetDlgItem(hwnd,ID_CB_LOCAL));
   localPath[Edit_GetText(GetDlgItem(hwnd,ID_EB_LOCAL),localPath,255)]='\0';

   nocache=Button_GetCheck(GetDlgItem(hwnd,ID_CB_NOCACHE));

   save();
   return(PSNRET_NOERROR);
}

AdvancedDialogPage advancedDlg;

