#ifndef CONTEXTMODE_H
#define CONTEXTMODE_H

#define CM_PREFOCUS_PARAM     0x00000000     //set focus to parameter hwnd before popping up menu
#define CM_PREFOCUS_GLOBAL    0x00000001     //set focus to global hwnd before popping up menu
#define CM_PREFOCUS_NONE      0x00000002     //don't alter focus before popping up menu
#define CM_PREFOCUS_NULL      0x00000003     //set focus to NULL before popping up menu
#define CM_PREFOCUS_MASK      0x00000003

#define CM_POSTFOCUS_NONE     0x00000000     //leave focus as it is after menu finished
#define CM_POSTFOCUS_SAVE     0x00000004     //save and restore focus around menu popup

#define CM_MAINWIN_HIDE       0x00000000     //hide main window
#define CM_MAINWIN_SHOW       0x00000008     //show main window (if directed to by nCmdShow parameter to WinMain)

#define CM_TRACK_EX           0x00000000     //use TrackPopupMenuEx() to display menu
#define CM_TRACK_NOEX         0x00000010     //use TrackPopupMenu() to display menu

#define CM_MENUON_RDOWN       0x00000000     //menu on WM_RBUTTONDOWN
#define CM_MENUON_RUP         0x00000020     //menu on WM_RBUTTONUP
#define CM_MENUON_CX_WM       0x00000040     //menu on WM_CONTEXTMENU (using WebMask's hwnd)
#define CM_MENUON_CX_CLICK    0x00000060     //menu on WM_CONTEXTMENU (using clicked window's hwnd)
#define CM_MENUON_MASK        0x00000060
#define CM_MENUON_CX_MASK     0x00000040

#define CM_TRAYMSG_POST       0x00000000     //WM_TRAY_MOUSE should post its messages
#define CM_TRAYMSG_SEND       0x00000080     //WM_TRAY_MOUSE should send its messages

#define CM_TRAYTYPE_RDOWN     0x00000000     //WM_TRAY_MOUSE should post/send WM_RBUTTONDOWN
#define CM_TRAYTYPE_RUP       0x00000100     //WM_TRAY_MOUSE should post/send WM_RBUTTONUP
#define CM_TRAYTYPE_CONTEXT   0x00000200     //WM_TRAY_MOUSE should post/send WM_CONTEXTMENU
#define CM_TRAYTYPE_SELF      0x00000300     //WM_TRAY_MOUSE should pop up menu itself
#define CM_TRAYTYPE_MASK      0x00000300

#define CM_CURPOS_CURSOR      0x00000000     //use GetCursorPos() to get cursor position for menu
#define CM_CURPOS_MESSAGE     0x00000400     //use GetMessagePos() to get cursor position for menu

#define CM_MENUPOS_SPECIFIED  0x00000000     //pop up menu at specified coordinates
#define CM_MENUPOS_WEBMASK    0x00000800     //pop up menu over WebMask window position
#define CM_MENUPOS_PARAMETER  0x00001000     //pop up menu over parameter hwnd window position
#define CM_MENUPOS_256_256    0x00001800     //pop up menu at 256,256
#define CM_MENUPOS_MASK       0x00001800

#define CM_ZORDER_NORMAL      0x00000000     //main window should move around z-order normally
#define CM_ZORDER_TOPMOST     0x00002000     //main window should be topmost

#define CM_SAVEEXIT_NO        0x00000000     //don't save main window position
#define CM_SAVEEXIT_YES       0x00004000     //save main window position on exit

#define CM_LOADSTART_NO       0x00000000     //don't load main window position
#define CM_LOADSTART_YES      0x00008000     //load main window position on startup

#define CM_WINTYPE_NORMAL     0x00000000     //main window should be a normal window
#define CM_WINTYPE_TOOL       0x00010000     //main window should be a tool window

#define CM_PREPOPUP_FOCUS     0x00000000     //use SetFocus before menu popups
#define CM_PREPOPUP_FGD       0x00020000     //use SetForegroundWindow before menu popups (see Q135788)

#define CM_POSTPOPUP_NONE     0x00000000     //no message sent after TrackPopupMenu[Ex]()
#define CM_POSTPOPUP_NULL     0x00040000     //post a null message after TrackPopupMenu[Ex]() (see Q135788)

#define CM_DISPMODE_YES       0x00000000     //Display contextMode setting in title if any other bit is set
#define CM_DISPMODE_NO        0x00080000     //Don't display contextMode setting in title

#endif

