#define STRICT
#include <windows.h>
#include <windowsx.h>
#pragma hdrstop

#include <stdio.h>
#include <commctrl.h>

#include "WebMask.h"
#include "Dialog.h"
#include "Resource.h"
#include "ContextMode.h"

class DebugDialogPage:public DialogPage{
   inline void setRadio(HWND hwnd,int base,unsigned int mask);
   inline void setCheck(HWND hwnd,int base,unsigned int mask);
   inline void getRadio(HWND hwnd,int base,unsigned int mask);
   inline void getCheck(HWND hwnd,int base,unsigned int mask);
public:
   DebugDialogPage(WORD dialog):DialogPage(dialog,ICON_DEBUG){}
   virtual void save();
   virtual void load();
//   virtual void enable(HWND);
   virtual BOOL init(HWND,HWND,LPARAM);
//   virtual void exit();
   virtual void command(HWND hwnd,int id,HWND hwndCtl,UINT notify);
   virtual int apply(HWND hwnd,int,LPNMHDR pnmhdr);
};

void DebugDialogPage::load(){
   HKEY hkey;
   if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\PseudoFoo\\WebMask",0,
                   KEY_READ,&hkey)!=ERROR_SUCCESS)
      hkey=NULL;
   LoadRegDwordDef (hkey,"contextMode",contextMode ,0xe0000                );
   LoadRegDwordDef (hkey,"autoRetry"  ,autoRetry   ,0                      );

   if(hkey) RegCloseKey(hkey);
}

void DebugDialogPage::save(){
   HKEY hkey;
   if(RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\PseudoFoo\\WebMask",0,
                     NULL,REG_OPTION_NON_VOLATILE,
                     KEY_READ|KEY_WRITE,NULL,&hkey,NULL)==ERROR_SUCCESS){
      SaveRegDword (hkey,"contextMode",contextMode );
      SaveRegDword (hkey,"autoRetry"  ,autoRetry );

      RegCloseKey(hkey);
   }
}

inline void DebugDialogPage::setRadio(HWND hwnd,int base,unsigned int mask){
   HWND hDlgWnd=GetDlgItem(hwnd,base);
   if(!hDlgWnd) return;
   Button_SetCheck(hDlgWnd,(contextMode&mask)==0);
   Button_SetCheck(GetDlgItem(hwnd,base+1),(contextMode&mask)==mask/3);
   Button_SetCheck(GetDlgItem(hwnd,base+2),(contextMode&mask)==mask/3*2);
   Button_SetCheck(GetDlgItem(hwnd,base+3),(contextMode&mask)==mask);
}

inline void DebugDialogPage::setCheck(HWND hwnd,int base,unsigned int mask){
   HWND hDlgWnd=GetDlgItem(hwnd,base);
   if(!hDlgWnd) return;
   Button_SetCheck(hDlgWnd,(contextMode&mask)!=0);
}

inline void DebugDialogPage::getRadio(HWND hwnd,int base,unsigned int mask){
   if(!GetDlgItem(hwnd,base)) return;
   contextMode&=~mask;
   if(Button_GetCheck(GetDlgItem(hwnd,base+1))) contextMode|=mask/3;
   else if(Button_GetCheck(GetDlgItem(hwnd,base+2))) contextMode|=mask/3*2;
   else if(Button_GetCheck(GetDlgItem(hwnd,base+3))) contextMode|=mask;
}

inline void DebugDialogPage::getCheck(HWND hwnd,int base,unsigned int mask){
   HWND hDlgWnd=GetDlgItem(hwnd,base);
   if(!hDlgWnd) return;
   contextMode&=~mask;
   if(Button_GetCheck(hDlgWnd)) contextMode|=mask;
}

BOOL DebugDialogPage::init(HWND hwnd,HWND,LPARAM){
   setRadio(hwnd,ID_RB_CM_0_0,CM_PREFOCUS_MASK);
   setCheck(hwnd,ID_CB_CM_2,CM_POSTFOCUS_SAVE);
   setCheck(hwnd,ID_CB_CM_3,CM_MAINWIN_SHOW);
   setCheck(hwnd,ID_CB_CM_4,CM_TRACK_NOEX);
   setRadio(hwnd,ID_RB_CM_5_0,CM_MENUON_MASK);
   setCheck(hwnd,ID_CB_CM_7,CM_TRAYMSG_SEND);
   setRadio(hwnd,ID_RB_CM_8_0,CM_TRAYTYPE_MASK);
   setCheck(hwnd,ID_CB_CM_A,CM_CURPOS_MESSAGE);
   setRadio(hwnd,ID_RB_CM_B_0,CM_MENUPOS_MASK);
   setCheck(hwnd,ID_CB_CM_D,CM_ZORDER_TOPMOST);
   setCheck(hwnd,ID_CB_CM_E,CM_SAVEEXIT_YES);
   setCheck(hwnd,ID_CB_CM_F,CM_LOADSTART_YES);
   setCheck(hwnd,ID_CB_CM_10,CM_WINTYPE_TOOL);
   setCheck(hwnd,ID_CB_CM_11,CM_PREPOPUP_FGD);
   setCheck(hwnd,ID_CB_CM_12,CM_POSTPOPUP_NULL);
   setCheck(hwnd,ID_CB_CM_13,CM_DISPMODE_NO);

   HWND hDlgWnd=GetDlgItem(hwnd,ID_CB_AUTORETRY);
   if(hDlgWnd) Button_SetCheck(hDlgWnd,autoRetry);

   enable(hwnd);
   return(TRUE);
}

void DebugDialogPage::command(HWND hwnd,int id,HWND hwndCtl,UINT notify){
   switch(id){
      case IDM_WHATS_THIS:
         break;
      default:
         DialogPage::command(hwnd,id,hwndCtl,notify);
   }

   enable(hwnd);
}

int DebugDialogPage::apply(HWND hwnd,int,LPNMHDR){
   getRadio(hwnd,ID_RB_CM_0_0,CM_PREFOCUS_MASK);
   getCheck(hwnd,ID_CB_CM_2,CM_POSTFOCUS_SAVE);
   getCheck(hwnd,ID_CB_CM_3,CM_MAINWIN_SHOW);
   getCheck(hwnd,ID_CB_CM_4,CM_TRACK_NOEX);
   getRadio(hwnd,ID_RB_CM_5_0,CM_MENUON_MASK);
   getCheck(hwnd,ID_CB_CM_7,CM_TRAYMSG_SEND);
   getRadio(hwnd,ID_RB_CM_8_0,CM_TRAYTYPE_MASK);
   getCheck(hwnd,ID_CB_CM_A,CM_CURPOS_MESSAGE);
   getRadio(hwnd,ID_RB_CM_B_0,CM_MENUPOS_MASK);
   getCheck(hwnd,ID_CB_CM_D,CM_ZORDER_TOPMOST);
   getCheck(hwnd,ID_CB_CM_E,CM_SAVEEXIT_YES);
   getCheck(hwnd,ID_CB_CM_F,CM_LOADSTART_YES);
   getCheck(hwnd,ID_CB_CM_10,CM_WINTYPE_TOOL);
   getCheck(hwnd,ID_CB_CM_11,CM_PREPOPUP_FGD);
   getCheck(hwnd,ID_CB_CM_12,CM_POSTPOPUP_NULL);
   getCheck(hwnd,ID_CB_CM_13,CM_DISPMODE_NO);

   HWND hDlgWnd=GetDlgItem(hwnd,ID_CB_AUTORETRY);
   if(hDlgWnd) autoRetry=Button_GetCheck(hDlgWnd);

   NewContextMode();
   ConnectCount::show();

   save();
   return(PSNRET_NOERROR);
}

DebugDialogPage debugDlg0(DIALOG_DEBUG0);
DebugDialogPage debugDlg1(DIALOG_DEBUG1);

