#define STRICT
#include <windows.h>
#include <windowsx.h>
#pragma hdrstop

//#include <stdio.h>
#include <commctrl.h>

#include "WebMask.h"
#include "Dialog.h"

HWND hPropWnd=NULL;

DWORD DialogPage::n;
DWORD DialogPage::lastNum;

DialogPage*DialogPage::first;

DialogPage::DialogPage(WORD dialog,WORD icon,
      HelpTopics*helpIds,unsigned int nHelpIds,
      char*helpDir,char*helpPage):
   dialog(dialog),icon(icon),
   helpIds(helpIds),nHelpIds(nHelpIds),
   helpDir(helpDir),helpPage(helpPage)
{
   next=first;
   first=this;
   myNum=n++;
}

void DialogPage::Save(){
   for(DialogPage*p=first;p;p=p->next) p->save();
}

void DialogPage::Load(){
   for(DialogPage*p=first;p;p=p->next) p->load();
}

int CALLBACK PropSheetProc(HWND hwnd,UINT,LPARAM){
   SetWindowLong(hwnd,GWL_EXSTYLE,GetWindowLong(hwnd,GWL_EXSTYLE)|WS_EX_APPWINDOW);
   hPropWnd=hwnd;
//   for(int pageno=0;pageno<NDLG;++pageno) PropSheet_SetCurSel(hwnd,NULL,pageno);
//   PropSheet_SetCurSel(hwnd,NULL,0);
   return(0);
}

UINT CALLBACK PropSheetPageProc(HWND hwnd,UINT msg,LPPROPSHEETPAGE psp){
   if(msg==PSPCB_CREATE){
      SetWindowLong(hwnd,DWL_USER,psp->lParam);
      return(TRUE);
   }else{
      DialogPage*dp=(DialogPage*)psp->lParam;
      dp->exit();
   }
   return(0);
}

volatile UINT timID=NULL;
int timcount;
RECT timRect;
HBITMAP bm0=NULL;
HBITMAP bm1=NULL;
char*bm0buf=NULL;
char*bm1buf=NULL;

struct BITMAPINFO256{
   BITMAPINFOHEADER bmiHeader;
   RGBQUAD bmiColors[256];
};
void startTimer(HWND hwnd){
   if(!timID){
      GetClientRect(hwnd,&timRect);

      HDC hDC=GetDC(hwnd);

      BITMAPINFO256 bminfo;
      for(int i=0;i<256;++i) ((unsigned short*)bminfo.bmiColors)[i]=(unsigned short)i;
      bminfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
      bminfo.bmiHeader.biWidth=timRect.right;
      bminfo.bmiHeader.biHeight=-timRect.bottom;
      bminfo.bmiHeader.biPlanes=1;
      bminfo.bmiHeader.biBitCount=8;
      bminfo.bmiHeader.biCompression=BI_RGB;
      bminfo.bmiHeader.biSizeImage=0;
      bminfo.bmiHeader.biXPelsPerMeter=0;
      bminfo.bmiHeader.biYPelsPerMeter=0;
      bminfo.bmiHeader.biClrUsed=0;
      bminfo.bmiHeader.biClrImportant=0;
      bm0=CreateDIBSection(hDC,(BITMAPINFO*)&bminfo,DIB_PAL_COLORS,(void**)&bm0buf,NULL,0);
      bm1=CreateDIBSection(hDC,(BITMAPINFO*)&bminfo,DIB_PAL_COLORS,(void**)&bm1buf,NULL,0);

      HDC bm0DC=CreateCompatibleDC(hDC);
      SelectObject(bm0DC,bm0);
      BitBlt(bm0DC,0,0,timRect.right,timRect.bottom,hDC,0,0,SRCCOPY);
      DeleteDC(bm0DC);

      ReleaseDC(hwnd,hDC);

      timcount=0;
      timID=SetTimer(hwnd,NULL,55,NULL);
   }
}

inline void stopTimer(HWND hwnd){
   if(timID){
      UINT i=timID;
      timID=NULL;
      KillTimer(hwnd,i);
      DeleteObject(bm1);
      DeleteObject(bm0);
      bm0=bm1=NULL;
      bm0buf=bm1buf=NULL;
   }
}

#define TIMMAX 128

void Prop_OnTimer(HWND hwnd,UINT){
   if(!timID) return;

   if((++timcount)>TIMMAX){
      stopTimer(hwnd);
      InvalidateRect(hwnd,NULL,FALSE);
      return;
   }

   int rx=timRect.right;
   int bx=timRect.bottom;
   const int w=(rx+3)&~3;
   int w1x=0;
   int wbxrx=bx*w+rx;

   for(int x=0;(x<<1)<=timRect.right&&(x<<1)<=timRect.bottom;++x){
      --rx;--bx;
      wbxrx-=w+1;
      const int n0=rx-x;
      const int n1=n0+bx-x;
      const int n2=n1+n0;
      const int n3=n1+n1;
      int c1=timcount*n3/TIMMAX-1;
      if(c1<0) c1=n3-1;
      else if(c1>=n3) c1=0;
      int t0=c1-n1;
      int t1=n1-1;
      for(int c0=n3;--c0>=0;--t1){
         int t2,t3;
         bm1buf[(t0>=0)?(((t2=c1-n2)>=0)?(x+w*(bx-t2)):(wbxrx-t0))
                       :(((t2=c1-n0)>=0)?(rx+w*(x+t2)):(w1x+c1  ))]=
         bm0buf[(t1>=0)?(((t3=c0-n2)>=0)?(x+w*(bx-t3)):(wbxrx-t1))
                       :(((t3=c0-n0)>=0)?(rx+w*(x+t3)):(w1x+c0  ))];
         if(--c1>=0) --t0;
         else t0+=(c1=n3-1);
      }
      w1x+=w+1;
   }

   HDC hDC=GetDC(hwnd);
   HDC bm1DC=CreateCompatibleDC(hDC);
   SelectObject(bm1DC,bm1);
   BitBlt(hDC,0,0,timRect.right,timRect.bottom,bm1DC,0,0,SRCCOPY);
   DeleteDC(bm1DC);
   ReleaseDC(hwnd,hDC);
}


HINSTANCE DialogPage::LoadPage(char*name){
   char buf[1024];
   wsprintf(buf,"http://127.0.0.1:%u/%s",myPort,name);
   HCURSOR hCursor=SetCursor(LoadCursor(NULL,IDC_WAIT));
   ShowCursor(TRUE);
   HINSTANCE r=ShellExecute(NULL,NULL,buf,NULL,NULL,SW_SHOW);
   ShowCursor(FALSE);
   SetCursor(hCursor);
   return(r);
}

void DialogPage::LoadHelp(HWND,int id){
   for(unsigned int i=0;i<nHelpIds;++i){
      if(helpIds[i].id==(unsigned long)id){
         char pagename[512];
         wsprintf(pagename,"%s/%s?%s.html",helpDir,helpPage,helpIds[i].name);
         LoadPage(pagename);
         return;
      }
   }
   char pagename[512];
   wsprintf(pagename,"%s/%s",helpDir,helpPage);
   LoadPage(pagename);
}

void DialogPage::LoadHelp(HWND hwnd,HWND idWnd,int x,int y){
   if(idWnd){
      for(unsigned int i=0;i<nHelpIds;++i){
         if(GetDlgItem(hwnd,int(helpIds[i].id))==idWnd){
            char pagename[512];
            wsprintf(pagename,"%s/%s?%s.html",helpDir,helpPage,helpIds[i].name);
            LoadPage(pagename);
            return;
         }
      }
   }
   for(unsigned int i=0;i<nHelpIds;++i){
      RECT rect;
      GetWindowRect(GetDlgItem(hwnd,int(helpIds[i].id)),&rect);
      if(x>=rect.left&&x<rect.right&&y>=rect.top&&y<rect.bottom){
         char pagename[512];
         wsprintf(pagename,"%s/%s?%s.html",helpDir,helpPage,helpIds[i].name);
         LoadPage(pagename);
         return;
      }
   }
   char pagename[512];
   wsprintf(pagename,"%s/%s",helpDir,helpPage);
   LoadPage(pagename);
}

inline void DialogPage::help(HWND hwnd,HELPINFO*lphi){
   if(!nHelpIds) return;
   LoadHelp(hwnd,lphi->iCtrlId);
}

void DialogPage::contextMenu(HWND hwnd,HWND hItemHandle,int x,int y){
   if(!nHelpIds) return;
   helpItem=hItemHandle;
   helpX=x;
   helpY=y;
   HMENU hMenu=CreatePopupMenu();
   MenuAddString(hMenu,"&What's This?",IDM_WHATS_THIS);

//   TrackPopupMenu(hMenu,TPM_LEFTALIGN|TPM_RIGHTBUTTON,x,y,0,hwnd,NULL);
   TrackPopupMenuEx(hMenu,TPM_LEFTALIGN|TPM_RIGHTBUTTON,x,y,hwnd,NULL);

   DestroyMenu(hMenu);
}

int DialogPage::notify(HWND hwnd,int idFrom,LPNMHDR pnmhdr){
   switch(pnmhdr->code){
      case PSN_HELP:{
         if(GetKeyState(VK_SHIFT)<0&&GetKeyState(VK_CONTROL)<0){
            startTimer(hwnd);
         }else{
            char pagename[512];
            wsprintf(pagename,"%s/%s",helpDir,helpPage);
            LoadPage(pagename);
         }
         break;
      }
      case PSN_APPLY:{
         return(apply(hwnd,idFrom,pnmhdr));
      }
      case PSN_KILLACTIVE:{
         stopTimer(hwnd);
         break;
      }
      case PSN_SETACTIVE:{
         lastNum=myNum;
         break;
      }
   }
   return(0);
}

BOOL DialogPage::dialogProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam){
   switch(msg){
      HANDLE_MSG(hwnd,WM_INITDIALOG,      init);
      HANDLE_MSG(hwnd,WM_COMMAND,         command);
      HANDLE_MSG(hwnd,WM_HELP,            help);
      HANDLE_MSG(hwnd,WM_CONTEXTMENU,     contextMenu);
      HANDLE_MSG(hwnd,WM_TIMER,           Prop_OnTimer);
      HANDLE_MSG(hwnd,WM_NOTIFY,          notify);
   }
   return(FALSE);
}

BOOL CALLBACK DialogProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam){
   if(msg==WM_INITDIALOG){
      SetWindowLong(hwnd,DWL_USER,((PROPSHEETPAGE*)lParam)->lParam);
   }
   DialogPage*dp=(DialogPage*)GetWindowLong(hwnd,DWL_USER);
   if(!dp) return(FALSE);
   return(dp->dialogProc(hwnd,msg,wParam,lParam));
}

void DialogPage::command(HWND hwnd,int id,HWND,UINT){
   switch(id){
      case IDM_WHATS_THIS:
         LoadHelp(hwnd,helpItem,helpX,helpY);
         break;
      default:
         PropSheet_Changed(hPropWnd,hwnd);
   }

   enable(hwnd);
}


void DialogPage::Properties(HWND hwnd){
   if(!n) return;

   HKEY wmKey;
   if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\PseudoFoo\\WebMask",0,
                   KEY_READ,&wmKey)==ERROR_SUCCESS){
      LoadRegDwordDef(wmKey,"dialogPage",lastNum,0);
      RegCloseKey(wmKey);
   }else lastNum=0;

   PROPSHEETPAGE*psp=new PROPSHEETPAGE[(unsigned int)n];
   PROPSHEETPAGE*ppsp=psp+n;
   for(DialogPage*p=first;p;p=p->next){
      --ppsp;
      ppsp->dwSize=sizeof(PROPSHEETPAGE);
      ppsp->dwFlags=(p->helpIds?PSP_HASHELP:0)|PSP_USEICONID|PSP_USECALLBACK;
      ppsp->hInstance=hInst;
      ppsp->pszTemplate=MAKEINTRESOURCE(p->dialog);
      ppsp->pszIcon=MAKEINTRESOURCE(p->icon);
      ppsp->pszTitle=NULL;
      ppsp->pfnDlgProc=DialogProc;
      ppsp->lParam=(LPARAM)p;
      ppsp->pfnCallback=PropSheetPageProc;
      ppsp->pcRefParent=NULL;
   }
   PROPSHEETHEADER psh;
   psh.dwSize=sizeof(PROPSHEETHEADER);
   psh.dwFlags=PSH_HASHELP|PSH_USEICONID|PSH_PROPSHEETPAGE|PSH_USECALLBACK;
   psh.hwndParent=hwnd;
   psh.hInstance=hInst;
   psh.pszIcon=MAKEINTRESOURCE(ICON_SMALL);
   psh.pszCaption="WebMask Properties";
   psh.nPages=(unsigned int)n;
   psh.nStartPage=lastNum;
   psh.ppsp=psp;
   psh.pfnCallback=PropSheetProc;
   PropertySheet(&psh);
   hPropWnd=NULL;

   if(RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\PseudoFoo\\WebMask",0,
                     NULL,REG_OPTION_NON_VOLATILE,
                     KEY_READ|KEY_WRITE,NULL,&wmKey,NULL)==ERROR_SUCCESS){
      SaveRegDword(wmKey,"dialogPage",lastNum);
      RegCloseKey(wmKey);
   }
}

void Properties(HWND hwnd){
   if(hPropWnd) SetForegroundWindow(hPropWnd);
   else DialogPage::Properties(hwnd);
}


void PrefLoad(){
   DialogPage::Load();
}

