#define STRICT
#include <windows.h>
#include <windowsx.h>
#pragma hdrstop

#include <stdio.h>
#include <fstream.h>

#include "WebMask.h"
#include "Dialog.h"
#include "Resource.h"
#include "sock.h"
#include "ContextMode.h"

#define NTHREADS 4
#define SPEEDHISTLEN 8

#ifdef __CONSOLE__
#define CSDEBUG
int main(){
   return(WinMain(HINSTANCE(GetModuleHandle(NULL)),NULL,"",SW_SHOWNORMAL));
}
#endif

//#define SetThreadPriority(x,y)

#ifdef CSDEBUG
#include <iostream.h>
#endif

HICON hIconBusy;
HICON hIconIdle;
HICON hIconStall;

char gfullfilename[1024];
char* gpartfilename=gfullfilename;

bool stall=false;
char speedText[256]="";

NOTIFYICONDATA nid;

HINSTANCE hInst;
HWND hwnd;

DWORD contextMode;
DWORD autoRetry;
Socket listenSocket;
BOOL enabled=TRUE;
BOOL startEnabled=TRUE;
BOOL useprox=FALSE;
BOOL usetun=TRUE;
char proxname[256]="www-cache.demon.co.uk";
unsigned long proxip=0x7c01989e;
unsigned short proxport=8080;
char tunname[256]="127.0.0.1";
unsigned short tunport=9999;
unsigned long tunip=0x0100007f;
unsigned short myPort=8080;
//BOOL anon=FALSE;
BOOL anonUserAgent=FALSE;
BOOL anonUA=FALSE;
BOOL anonReferer=FALSE;
BOOL anonFrom=FALSE;

ViaType viaType=genuine;
char viaText[256]="1.0 name (WebMask/"WEBMASK_VERSION_NS")";

BOOL useLocal=FALSE;
char localPath[256]="";

BOOL nocache=FALSE;
BOOL gopherImages=FALSE;

char filterFile[256]="";

#ifdef CSDEBUG
class Critical{
public:
   class Section{
      CRITICAL_SECTION cs;
   public:
      Section(){InitializeCriticalSection(&cs);}
      ~Section(){DeleteCriticalSection(&cs);}
      void enter(){EnterCriticalSection(&cs);}
      void leave(){LeaveCriticalSection(&cs);}
   }&s;
   static Section ds;
   char*name;
   Critical(Section&s,char*name):s(s),name(name){
      ds.enter();cout<<(void*)GetCurrentThreadId()<<' '<<name<<"{"<<endl;ds.leave();
      s.enter();
      ds.enter();cout<<(void*)GetCurrentThreadId()<<' '<<name<<"{*"<<endl;ds.leave();
   }
   ~Critical(){
      ds.enter();cout<<(void*)GetCurrentThreadId()<<' '<<name<<"*}"<<endl;ds.leave();
      s.leave();
      ds.enter();cout<<(void*)GetCurrentThreadId()<<' '<<name<<"}"<<endl;ds.leave();
   }
};
Critical::Section Critical::ds;
#define DBG(x) Critical::ds.enter();cout<<(void*)GetCurrentThreadId()<<' '<<x<<endl;Critical::ds.leave();
#define section(x) section_(x,#x)
#else
class Critical{
public:
   class Section{
      CRITICAL_SECTION cs;
   public:
      Section(){InitializeCriticalSection(&cs);}
      ~Section(){DeleteCriticalSection(&cs);}
      void enter(){EnterCriticalSection(&cs);}
      void leave(){LeaveCriticalSection(&cs);}
   }&s;
   Critical(Section&s):s(s){s.enter();}
   ~Critical(){s.leave();}
};
#define DBG(x)
#endif

Critical::Section csIP;
Critical::Section csDraw;
Critical::Section csCount;

Critical::Section csDebug;
#define DEBUG(x) {Critical section(csDebug);ofstream("webmask.debug.txt",ios::out|ios::app)<<GetCurrentThreadId()<<' '<<x<<endl;}
//#define DEBUG(x)

struct HistoryItem{
   static HistoryItem*first;
   static HistoryItem*last;
   static int used;

   HistoryItem*next;
   HistoryItem*prev;
   char*text;
   HistoryItem(char*item):next(NULL),prev(NULL),
      text(item?new char[1+strlen(item)]:NULL){
      if(item) strcpy(text,item);
      next=first;
      first=this;
      if(next) next->prev=this;
      if(!last) last=this;
      ++used;
   }
   ~HistoryItem();
};

HistoryItem::~HistoryItem(){
   //compiler bug treats "last" as meaning "this" if this functions is put inline.
   --used;
   if(prev) prev->next=next;
   if(next) next->prev=prev;
   if(first==this) first=next;
   if(last==this) last=prev;
   next=prev=NULL;
   delete[](text);
}

HistoryItem*HistoryItem::first=NULL;
HistoryItem*HistoryItem::last=NULL;
int HistoryItem::used=0;

void ShowText(HWND hwnd,HDC hDC,int scroll,int paint){
   NONCLIENTMETRICS ncm;
   ncm.cbSize=sizeof(NONCLIENTMETRICS);
   SystemParametersInfo(SPI_GETNONCLIENTMETRICS,0,&ncm,0);
   LOGFONT&lf=(contextMode&CM_WINTYPE_TOOL)?ncm.lfSmCaptionFont:ncm.lfCaptionFont;

   HFONT hFont=CreateFontIndirect(&lf);
   HFONT hOldFont=SelectFont(hDC,hFont);

   RECT rect;

   TEXTMETRIC tm;
   GetTextMetrics(hDC,&tm);
   if(scroll){
      ScrollWindowEx(hwnd,0,-scroll*tm.tmHeight,NULL,NULL,NULL,&rect,0);
      FillRect(hDC,&rect,(HBRUSH)(1+COLOR_BTNFACE));
//      InvalidateRect(hwnd,&rect,TRUE);
   }
   GetClientRect(hwnd,&rect);
   int fit=(rect.bottom+tm.tmHeight-1)/tm.tmHeight;

   while(HistoryItem::used>fit){
      delete(HistoryItem::last);
   }
//   char buf[256];
//   wsprintf(buf,"%d/%d",HistoryItem::used,fit);
//   SetWindowText(hwnd,buf);
   rect.top=rect.bottom-tm.tmHeight;

   SetTextColor(hDC,GetSysColor(COLOR_BTNTEXT));
   SetBkColor(hDC,GetSysColor(COLOR_BTNFACE));

   HistoryItem*h=HistoryItem::first;
   if(!paint) --paint;
   while(paint--&&h){
      DrawText(hDC,h->text,-1,&rect,DT_SINGLELINE|DT_NOPREFIX|DT_BOTTOM|DT_LEFT);
      h=h->next;
      rect.top-=tm.tmHeight;
      rect.bottom-=tm.tmHeight;
   }
   SelectFont(hDC,hOldFont);
   DeleteFont(hFont);
}

void NewText(HWND hwnd,char*text){
   DBG("NewText+");
   Critical section(csDraw);
   new HistoryItem(text);

   HDC hDC=GetDC(hwnd);
   ShowText(hwnd,hDC,1,1);
   ReleaseDC(hwnd,hDC);
   DBG("NewText-");
}

//int ysize=0;
inline void WebMask_OnSize(HWND hwnd,UINT,int x,int y){
//   RECT rect;
//   ScrollWindowEx(hwnd,0,y-ysize,NULL,NULL,NULL,&rect,0);
//   ysize=y;
//   HDC hDC=GetDC(hwnd);
//   FillRect(hDC,&rect,(HBRUSH)(1+COLOR_BTNFACE));
//   ReleaseDC(hwnd,hDC);
}

#ifdef _MSC_VER
   #define MS_KLUDGE 1
#else
   #define MS_KLUDGE 0
#endif

char transGif[42+MS_KLUDGE]="GIF89a\x02\x00\x01\x00\x80\x00\x00\x00\x00\x00"
                  "\xff\xff\xff\x21\xf9\x04\x01\x00\x00\x00\x00\x2c\x00\x00\x00\x00"
                  "\x02\x00\x01\x00\x00\x02\x01\x04\x00\x3b";


unsigned long ConnectCount::n=0;

void ConnectCount::show(){
   DBG("ConnectCount::show+");
   {
      Critical section(csCount);
      unsigned int n=ConnectCount::n;
      if(contextMode&&!(contextMode&CM_DISPMODE_NO))
         wsprintf(nid.szTip,"WebMask %sabled [%08x], %u connection%s%s",
            (enabled?"en":"dis"),contextMode,n,"s"+(n==1),speedText);
      else
         wsprintf(nid.szTip,"WebMask %sabled, %u connection%s%s",
            (enabled?"en":"dis"),n,"s"+(n==1),speedText);
      nid.hIcon=n?(stall?hIconStall:hIconBusy):hIconIdle;
   }
   DBG("ConnectCount::show...0");
//   Critical section(csDraw);
   DBG("ConnectCount::show...1");
   Shell_NotifyIcon(NIM_MODIFY,&nid);
   DBG("ConnectCount::show...2");
   SetWindowText(hwnd,nid.szTip);
   DBG("ConnectCount::show-");
}


FilterList::~FilterList(){
   while(f){
      Filter*n=f->next;
      delete(f);
      f=n;
   }
}

FilterList::FilterList(const FilterList&l):f(NULL){
   Filter**fp=&f;
   Filter*pf=NULL;
   Filter*n=l.f;
   while(n){
      *fp=new Filter(*n);
      (*fp)->prev=pf;
      pf=*fp;
      pf->num=-1;
      fp=&(pf->next);
      n=n->next;
   }
}

void FilterList::clearNum(){
   for(Filter*fp=f;fp;fp=fp->next)
      fp->num=-1;
}

void FilterList::setNum(Filter*filter,int n){
   delNum(filter->num);
   for(Filter*fp=f;fp;fp=fp->next){
      if(filter==fp) fp->num=n;
      else if(fp->num>=n) ++fp->num;
   }
}

void FilterList::delNum(int n){
   if(n==-1) return;
   for(Filter*fp=f;fp;fp=fp->next){
      if(fp->num==n) fp->num=-1;
      else if(fp->num>n) --fp->num;
   }
}

FilterList*activeFilters=NULL;

/*
bool needIP=true;

void calcIP(){
   HCURSOR hCursor=SetCursor(LoadCursor(NULL,IDC_WAIT));
   ShowCursor(TRUE);
   Critical section(csIP);
   needIP=true;
   ShowCursor(FALSE);
   SetCursor(hCursor);
}

void realCalcIP(){
   {
      if(!needIP) return;
      HCURSOR hCursor=SetCursor(LoadCursor(NULL,IDC_WAIT));
      ShowCursor(TRUE);
      Critical section(csIP);
      if(needIP){
         proxip=useprox?getip(proxname):INADDR_NONE;
         tunip=usetun?getip(tunname):INADDR_NONE;
      }
      ShowCursor(FALSE);
      SetCursor(hCursor);

      if(!needIP) return;
      needIP=false;
   }

//   char msg[1024];
//   wsprintf(msg,"useprox=%s proxname=%s proxip=%08x\n"
//                "usetun=%s  tunname=%s  tunip=%08x",
//                useprox?"true":"false",proxname,proxip,
//                usetun?"true":"false",tunname,tunip);
//   MessageBox(hwnd,msg,"WebMask debug",MB_ICONINFORMATION|MB_OK);

   if(useprox&&proxip==INADDR_NONE){
      if(usetun&&tunip==INADDR_NONE)
         MessageBox(NULL,"Proxy and tunnel hosts are both unknown",
                    "WebMask warning",MB_ICONEXCLAMATION|MB_OK);
      else
         MessageBox(NULL,"Proxy host is unknown",
                    "WebMask warning",MB_ICONEXCLAMATION|MB_OK);
   }else if(usetun&&tunip==INADDR_NONE)
      MessageBox(NULL,"Tunnel host is unknown",
                 "WebMask warning",MB_ICONEXCLAMATION|MB_OK);
}
*/

BOOL FilterList::matchFilters(char*name,char*url){
   Filter*ff=f;
   while(ff){
      if(ff->name&&!stricmp(name,ff->name)
         &&((ff->pathType==Filter::EXACT&&ff->exact&&!strcmp(url,ff->exact))
            ||(ff->pathType==Filter::PARTIAL&&(!ff->start||!strncmp(url,ff->start,strlen(ff->start)))
                                   &&(!ff->end||!strcmp(url+strlen(url)-strlen(ff->end),ff->end)))))
         return(TRUE);
      ff=ff->next;
   }
   return(FALSE);
}

char myname[1024]="unknown";
int mynamelen;

void SocketFn(Socket&);

DWORD WINAPI ListenThread(Socket*ls){
   DBG("ListenThread+");
   Socket s;
   DBG("ListenThread...0");
   if(!s.connect(*ls)){
      DBG("ListenThread...1");
      DWORD id;
      HANDLE thread=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)ListenThread,ls,0,&id);
      DBG("ListenThread...2 ("<<(void*)id<<")");
      SetThreadPriority(thread,THREAD_PRIORITY_ABOVE_NORMAL);
      DBG("ListenThread...3");
      CloseHandle(thread);
      DBG("ListenThread...4");
      SocketFn(s);
   }
   DBG("ListenThread-");
   return(0);
}

int recvBytes[SPEEDHISTLEN];
DWORD recvTimes[SPEEDHISTLEN];
int recvPos=0;
bool recvFirst=true;

void WebMask_OnTimer(HWND,int){
   {
      Critical section(csCount);
      DWORD t=GetTickCount();
      if(recvFirst){
         for(int i=0;i<SPEEDHISTLEN;++i){
            recvBytes[i]=0;
            recvTimes[i]=t;
         }
         recvFirst=false;
      }
      int b=recvCount;
      int db=b-recvBytes[recvPos];
      recvBytes[recvPos]=b;
      DWORD dt=t-recvTimes[recvPos];
      recvTimes[recvPos]=t;
      if(++recvPos==SPEEDHISTLEN) recvPos=0;
      if(dt&&db){
         sprintf(speedText,", %0.3lfKb/s",double(db*1000)/double(dt*1024));
         stall=false;
      }else if(ConnectCount::n){
          strcpy(speedText,", 0Kb/s");
         stall=true;
      }else{
         *speedText='\0';
         stall=false;
      }
   }
   ConnectCount::show();
}

HANDLE timerThread=NULL;
bool timerActive=true;
DWORD CALLBACK TimerThread(void*){
   while(timerActive){
      WebMask_OnTimer(NULL,0);
      Sleep(1000);
   }
   return(0);
}

bool startListening(){
   listenSocket.disconnect();
   if(listenSocket.listen(myPort,INADDR_ANY)) return(FALSE);
   DWORD id;
   HANDLE thread;
   for(int i=0;i<NTHREADS;++i){
      thread=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)ListenThread,&listenSocket,0,&id);
      SetThreadPriority(thread,THREAD_PRIORITY_ABOVE_NORMAL);
      CloseHandle(thread);
   }
   return(TRUE);
}

BOOL WebMask_OnCreate(HWND hwnd,LPCREATESTRUCT){
   DWORD id;
   timerThread=CreateThread(NULL,0,TimerThread,NULL,0,&id);
//   SetTimer(hwnd,1,1000,NULL);

   return(startListening());
}

void WebMask_OnDestroy(HWND hwnd){
//   KillTimer(hwnd,1);
   timerActive=false;
   if(contextMode&CM_SAVEEXIT_YES){
      RECT rect;
      GetWindowRect(hwnd,&rect);
      HKEY hkey;
      if(RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\PseudoFoo\\WebMask",0,
                        NULL,REG_OPTION_NON_VOLATILE,
                        KEY_READ|KEY_WRITE,NULL,&hkey,NULL)==ERROR_SUCCESS){
         SaveRegNum(hkey,"window x",rect.left);
         SaveRegNum(hkey,"window y",rect.top);
         SaveRegNum(hkey,"window w",rect.right-rect.left);
         SaveRegNum(hkey,"window h",rect.bottom-rect.top);
         RegCloseKey(hkey);
      }
   }
   listenSocket.disconnect();
   PostQuitMessage(0);
}

void WebMask_OnPaint(HWND hwnd){
   DBG("OnPaint+");
   Critical section(csDraw);
   DBG("OnPaint...0");
   PAINTSTRUCT ps;
   HDC hDC=BeginPaint(hwnd,&ps);
   DBG("OnPaint...1");
   ShowText(hwnd,hDC,0,0);
   DBG("OnPaint...2");
   EndPaint(hwnd,&ps);
   DBG("OnPaint-");
}

class SocketLine{
   Socket&s;
   char*buf;
   char*bufpos;
   char*bufend;
   unsigned int buflen;
   unsigned int waiting;
public:
   BOOL eof;
   SocketLine(Socket&sock):s(sock),buf(NULL),bufpos(NULL),bufend(NULL),
                           buflen(0),waiting(0),eof(FALSE){}
   ~SocketLine(){if(buf) delete[](buf);}
   BOOL getline();
   char*linebuf(){return(buf);}
   unsigned int linelen(){return((unsigned int)(buf?bufend-buf:0));}
   char*restbuf(){return(buf?bufpos:NULL);}
   unsigned int restlen(){return(waiting);}
   void eat(unsigned int n){
      if(n>waiting) n=waiting;
      waiting-=n;
      bufpos+=n;
   }
};

void HttpError(Socket&s,char*msg,bool winerr=false,DWORD err=0){
   DBG("HttpError+ "<<s.s<<"("<<s.open()<<")"<<msg<<","<<winerr<<","<<err);
   if(winerr&&!err) err=DWORD(WSAGetLastError());
   DBG("HttpError...0 "<<s.s<<"("<<s.open()<<")"<<msg<<","<<winerr<<","<<err);
   s.send("HTTP/1.0 400 WebMask Detected Error\r\n" //37
          "Content-Type: text/html\r\n" //25
          //Should really add Content-Length, but it's hard, and demon don't do so!
          "\r\n" //2
          "<html><head><title>WebMask error: ", //34
          98);
   DBG("HttpError...1 "<<s.s<<"("<<s.open()<<")"<<msg<<","<<winerr<<","<<err);
   s.send(msg);
   s.send("</title></head><body>\r\n" //23
          "<h1>WebMask error</h1><h2>", //26
          49);
   s.send(msg);
   s.send("</h2>\r\n",7);
   DBG("HttpError...2 "<<s.s<<"("<<s.open()<<")"<<msg<<","<<winerr<<","<<err);
   if(winerr){
      HLOCAL buf=NULL;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM,
                    NULL,
                    err,
                    NULL,
                    (char*)&buf,
                    NULL,NULL);
      char*desc=NULL;
      char dft[256];
      if(buf){
         desc=(char*)LocalLock(buf);
      }else if(err){
         switch(err){
            case WSAEINTR:          desc="A blocking call was cancelled (WSAEINTR)";break;
            case WSAEBADF:          desc="Bad function (WSAEBADF)";break;
            case WSAEACCES:         desc="Invalid broadcast attempt (WSAEACCES)";break;
            case WSAEFAULT:         desc="An invalid parameter was passed (WSAEFAULT)";break;
            case WSAEINVAL:         desc="The socket is not bound to an address (WSAEINVAL)";break;
            case WSAEMFILE:         desc="No more file descriptors are available (WSAEMFILE)";break;
            case WSAEWOULDBLOCK:    desc="This call would block, but the socket is non-blocking (WSAEWOULDBLOCK)";break;
            case WSAEINPROGRESS:    desc="A blocking call is in progress (WSAEINPROGRESS)";break;
            case WSAEALREADY:       desc="The routine has completed, so can't be cancelled (WSAEALREADY)";break;
            case WSAENOTSOCK:       desc="The descriptor is not a socket (WSAENOTSOCK)";break;
            case WSAEDESTADDRREQ:   desc="A destination address is required (WSAEDESTADDRREQ)";break;
            case WSAEMSGSIZE:       desc="More data is available than will fit in the buffer (WSAEMSGSIZE)";break;
            case WSAEPROTOTYPE:     desc="This protocol is no good for this socket (WSAEPROTOTYPE)";break;
            case WSAENOPROTOOPT:    desc="Unknown protocol option (WSAENOPROTOOPT)";break;
            case WSAEPROTONOSUPPORT:desc="This protocol is not supported (WSAEPROTONOSUPPORT)";break;
            case WSAESOCKTNOSUPPORT:desc="This socket type is not supoprted (WSAESOCKTNOSUPPORT)";break;
            case WSAEOPNOTSUPP:     desc="Operation not supported by this socket (WSAEOPNOTSUPP)";break;
            case WSAEPFNOSUPPORT:   desc="This protocol family is not supported (WSAEPFNOSUPPORT)";break;
            case WSAEAFNOSUPPORT:   desc="This adapter family is not supported (WSAEAFNOSUPPORT)";break;
            case WSAEADDRINUSE:     desc="The required address is already in use (WSAEADDRINUSE)";break;
            case WSAEADDRNOTAVAIL:  desc="The specified address is not available (WSAEADDRNOTAVAIL)";break;
            case WSAENETDOWN:       desc="The network has failed (WSAENETDOWN)";break;
            case WSAENETUNREACH:    desc="The network can't be reached (WSAENETUNREACH)";break;
            case WSAENETRESET:      desc="WinSock dropped the network connection (WSAENETRESET)";break;
            case WSAECONNABORTED:   desc="The virtual circuit was aborted due to timeout or failue (WSAECONNABORTED)";break;
            case WSAECONNRESET:     desc="The virtual circuit was reset at the other end (WSAECONNRESET)";break;
            case WSAENOBUFS:        desc="No buffer space available (WSAENOBUFS)";break;
            case WSAEISCONN:        desc="The socket is already connected (WSAEISCONN)";break;
            case WSAENOTCONN:       desc="The socket is not connected (WSAENOTCONN)";break;
            case WSAESHUTDOWN:      desc="The socket has been shut down (WSAESHUTDOWN)";break;
            case WSAETOOMANYREFS:   desc="Undocumented error (WSAETOOMANYREFS)";break;
            case WSAETIMEDOUT:      desc="Connect attempt timed out (WSAETIMEDOUT)";break;
            case WSAECONNREFUSED:   desc="The connection attempt was rejected (WSAECONNREFUSED)";break;
            case WSAELOOP:          desc="Undocumented error (WSAELOOP)";break;
            case WSAENAMETOOLONG:   desc="Name too long (WSAENAMETOOLONG)";break;
            case WSAEHOSTDOWN:      desc="The destination host is down (WSAEHOSTDOWN)";break;
            case WSAEHOSTUNREACH:   desc="The destination can't be reached (WSAEHOSTUNREACH)";break;
            case WSAENOTEMPTY:      desc="Undocumented error (WSAENOTEMPTY)";break;
            case WSAEPROCLIM:       desc="Undocumented error (WSAEPROCLIM)";break;
            case WSAEUSERS:         desc="Undocumented error (WSAEUSERS)";break;
            case WSAEDQUOT:         desc="Undocumented error (WSAEDQUOT)";break;
            case WSAESTALE:         desc="Undocumented error (WSAESTALE)";break;
            case WSAEREMOTE:        desc="Undocumented error (WSAEREMOTE)";break;
            case WSAEDISCON:        desc="Circuit closed gracefully (WSAEDISCON)";break;
            case WSASYSNOTREADY:    desc="Network not ready for communication (WSASYSNOTREADY)";break;
            case WSAVERNOTSUPPORTED:desc="WinSock version not supported (WSAVERNOTSUPPORTED)";break;
            case WSANOTINITIALISED: desc="WinSock was not initialised correctly (WSANOTINITIALISED)";break;
            case WSAHOST_NOT_FOUND: desc="Host not found (WSAHOST_NOT_FOUND)";break;
            case WSATRY_AGAIN:      desc="Host name unknown at this time; try again (WSATRY_AGAIN)";break;
            case WSANO_RECOVERY:    desc="A non-recoverable error occured looking up the host name (WSANO_RECOVERY)";break;
            case WSANO_DATA:        desc="The host doesn't exist (WSANO_DATA)";break;
            default:
               desc=dft;
               wsprintf(dft,"Error number %d",err);
         }
      }
      if(desc){
         s.send(desc);
         s.send("\r\n",2);
      }
      if(buf){
         LocalUnlock(buf);
         LocalFree(buf);
      }
   }
   s.send("</body></html>\r\n",16);
   DBG("HttpError- "<<s.s<<"("<<s.open()<<")"<<msg<<","<<winerr<<","<<err);
}

BOOL SocketLine::getline(){
   if(eof){
      if(buf){
         delete[](buf);
         bufpos=buf=NULL;
      }
      waiting=0;
      return(FALSE);
   }
   if(!buf){
      try{
         buf=new char[BUFLEN];
      }catch(...){}
      if(!buf){
         s.disconnect();
         ExitThread(1);
      }
      buflen=BUFLEN;
      bufpos=buf;
      waiting=0;
   }
   if(bufpos!=buf){
      char*src=bufpos;
      if(waiting+waiting>=buflen||buflen<=BUFLEN){
         bufpos=buf;
         for(unsigned int i=0;i<waiting;++i) *bufpos++=*src++;
      }else{
         while(waiting+waiting<buflen&&buflen>BUFLEN) buflen>>=1;
         char*buf2=NULL;
         try{
            buf2=new char[buflen];
         }catch(...){}
         if(!buf2){
            delete[](buf);
            s.disconnect();
            ExitThread(1);
         }
         bufpos=buf2;
         for(unsigned int i=0;i<waiting;++i) *bufpos++=*src++;
         delete[](buf);
         buf=buf2;
      }
      bufpos=buf;
   }

   for(;;){
      if(!waiting||(waiting<=2&&*bufpos=='\x0d'&&(waiting==1||bufpos[1]=='\x0d'))){
         if(waiting+(unsigned int)(bufpos-buf)==buflen){
            char*buf2=NULL;
            try{
               buf2=new char[buflen<<1];
            }catch(...){}
            if(!buf2){
               delete[](buf);
               s.disconnect();
               ExitThread(1);
            }
            char*dest=buf2;
            char*src=buf;
            for(unsigned int i=0;i<buflen;++i) *dest++=*src++;
            bufpos=dest-waiting;
            delete[](buf);
            buf=buf2;
            buflen<<=1;
         }
         int n=s.recvRaw(bufpos+waiting,int(buflen-(unsigned int)(bufpos-buf)-waiting));
         if(!n&&waiting){
            bufend=bufpos;
            bufpos+=waiting;
            waiting=0;
            eof=TRUE;
            break;
         }
         if(!n||n==SOCKET_ERROR){
            bufend=bufpos;
            eof=TRUE;
            *bufend='\x0d';
            return(FALSE);
         }
         waiting+=(unsigned int)n;
      }
      if(*bufpos=='\x0d'&&bufpos[1]=='\x0d'&&bufpos[2]=='\x0a'){
         bufend=bufpos;
         bufpos+=3;
         waiting-=3;
         break;
      }
      if(*bufpos=='\x0d'&&bufpos[1]=='\x0a'){
         bufend=bufpos;
         bufpos+=2;
         waiting-=2;
         break;
      }
      if(*bufpos=='\x0d'||*bufpos=='\x0a'){
         bufend=bufpos;
         ++bufpos;
         --waiting;
         break;
      }
      ++bufpos;
      --waiting;
   }
   return(TRUE);
}

class Buf{
   char*b;
   unsigned int buflen;
   unsigned int bufused;
public:
   Buf():b(NULL),buflen(0),bufused(0){}
   ~Buf(){if(b) delete[](b);}
   void add(char*data,unsigned int len);
   char*buf(){return(b);}
   unsigned int len(){return(bufused);}
};

void Buf::add(char*data,unsigned int len){
   if(!b){
      try{
         b=new char[BUFLEN];
      }catch(...){}
      buflen=BUFLEN;
      bufused=0;
   }
   unsigned int newlen=buflen;
   while(bufused+len>newlen) newlen<<=1;
   if(newlen!=buflen){
      char*b2=new char[newlen];
      char*src=b;
      char*dest=b2;
      for(unsigned int i=0;i<bufused;++i) *dest++=*src++;
      delete[](b);
      b=b2;
   }
   char*src=data;
   char*dest=b+bufused;
   for(unsigned int i=0;i<len;++i) *dest++=*src++;
   bufused+=len;
}

void SocketFn(Socket&s1){
   DBG("SocketFn+");
   ConnectCount counter;
//   realCalcIP();
   linger l;
   l.l_onoff=1;
   l.l_linger=10;
   s1.setopt(SOL_SOCKET,SO_LINGER,(char*)&l,sizeof(linger));
//   u_long tf=FALSE;
//   ioctlsocket(s1,FIONBIO,&tf);

   DBG("SocketFn...0");

   SocketLine line(s1);

   BOOL abort=FALSE;

   bool up=useprox;

   DBG("SocketFn...1");

   if(!line.getline()){
      HttpError(s1,"No request given");
      DBG("SocketFn-1");
      return;
   }

   char*buf=line.linebuf();
//   int len=line.linelen();

//   MessageBox(NULL,buf,"line",MB_OK);

   BOOL secure=FALSE;

   char*method=buf;

   unsigned long ip=0x0100007f;
   unsigned int httphi=0;
   unsigned int httplo=0;
   unsigned short port=80;
   char*url=NULL;
   char*http=NULL;
   char*host=NULL;

   int methodLen=0;
   char*methodStr;

   DBG("SocketFn...2");

   if(!strnicmp(method,"CONNECT ",8)){
      secure=TRUE;
      port=443;
      ip=getip(tunname);
   }

   if(!secure){
      char b;
      while((b=*buf)!=' '&&b!='\x09'&&b!='\x0d'&&b!='\x0a') ++buf;
      *buf++='\x0';
      if(b!='\x0d'&&b!='\x0a'){
         while(*buf==' '||*buf=='\x09') ++buf;
         url=buf;
         while((b=*buf)!=' '&&b!='\x09'&&b!='\x0d'&&b!='\x0a') ++buf;
         *buf++='\x0';
         if(b!='\x0d'&&b!='\x0a'){
            while(*buf==' '||*buf=='\x09') ++buf;
            http=buf;
            while((b=*buf)!=' '&&b!='\x09'&&b!='\x0d'&&b!='\x0a') ++buf;
            *buf='\x0';
         }
      }

      if(!url){
         HttpError(s1,"Invalid request (no path)");
         DBG("SocketFn-2");
         return;
      }

      if(http){
         if(strnicmp(http,"HTTP/",5)){
            HttpError(s1,"Invalid HTTP version");
            DBG("SocketFn-3");
            return;
         }
         char*ptr=http+5;
         char c;
         while((c=*ptr++)>='0'&&c<='9'){
            httphi*=10;
            httphi+=(unsigned int)(c-'0');
         }
         if(c!='.'){
            HttpError(s1,"Invalid HTTP version");
            DBG("SocketFn-4");
            return;
         }
         while((c=*ptr++)>='0'&&c<='9'){
            httplo*=10;
            httplo+=(unsigned int)(c-'0');
         }
         if(c){
            HttpError(s1,"Invalid HTTP version");
            DBG("SocketFn-5");
            return;
         }
      }else httplo=9;

      if(httphi>1||(!httphi&&httplo!=9)){
         HttpError(s1,"Unknown HTTP version");
         DBG("SocketFn-6");
         return;
      }

      bool localFile=false;
      char fullfilename[1024];
      char*partfilename;
      ifstream file;
      if(*url=='/'){
         char*ptr=url+1;
         while(*ptr&&*ptr!='/') ++ptr;
         if(*ptr=='/'&&ptr[-1]==':'){
            if(ptr[1]=='/') ++url;
            else{
               for(char*ptr2=url;ptr2<ptr;++ptr2) *ptr2=ptr2[1];
            }
         }
      }
      if(*url=='/'){
         char c;
         for(char *ptr=url;c=*ptr;++ptr){
            if(c==':'
               ||(c=='.'&&ptr[1]=='.')
               ||((c=='/'||c=='\\')&&(ptr[1]=='/'||ptr[1]=='\\')))
            {
               url="/WebMask.html";
               break;
            }else if(c=='?'){
               *ptr='\0';
               break;
            }
         }
//         MessageBox(NULL,url,"file",MB_OK);
         strcpy(fullfilename,gfullfilename);
         partfilename=fullfilename+(gpartfilename-gfullfilename);
         if(strlen(url)+partfilename-fullfilename+4>1023) url="/WebMask.html";
         wsprintf(partfilename,"help%s",url);
         localFile=true;
         file.open(fullfilename,ios::in|ios::binary);
         if(!file){
            strcpy(partfilename,"help/WebMask.html");
            file.open(fullfilename,ios::in|ios::binary);
         }
      }else if(gopherImages||useLocal){
         char*last=url;
         for(char*ptr=url;*ptr;++ptr) if(*ptr=='/') last=ptr;
         if(!strnicmp(last,"/internal-gopher-",17)){
            localFile=true;
            char c;
            for(char*ptr=last+17;c=*ptr;++ptr){
               if(c==':'||c=='.'||c=='\\'){
                  localFile=false;
                  break;
               }
            }
            if(localFile){
               strcpy(fullfilename,gfullfilename);
               partfilename=fullfilename+(gpartfilename-gfullfilename);
               wsprintf(partfilename,"images%s.gif",last);
               file.open(fullfilename,ios::in|ios::binary);
               if(!file)
                  localFile=false;
            }
         }
         if(useLocal&&!localFile){
            strcpy(fullfilename,localPath);
            partfilename=fullfilename+strlen(fullfilename);
            if(partfilename!=fullfilename&&partfilename[-1]!='\\')
               *partfilename++='\\';
            strcpy(partfilename,last);
            file.open(fullfilename,ios::in|ios::binary);
            if(file) localFile=true;
         }
      }
   DBG("SocketFn...3");
      if(localFile){
         if(!file){
            HttpError(s1,"File not found");
            DBG("SocketFn-7");
            return;
         }
         s1.send("HTTP/1.0 200 OK\r\nContent-Type: ",31);
   DBG("SocketFn...4");
         if(!stricmp(partfilename+strlen(partfilename)-5,".html")
            ||!stricmp(partfilename+strlen(partfilename)-4,".htm"))
            s1.send("text/html",9);
         else if(!stricmp(partfilename+strlen(partfilename)-4,".gif"))
            s1.send("image/gif");
         else if(!stricmp(partfilename+strlen(partfilename)-5,".jpeg")
                 ||!stricmp(partfilename+strlen(partfilename)-4,".jpg"))
            s1.send("image/jpeg");
         else if(!stricmp(partfilename+strlen(partfilename)-4,".zip"))
            s1.send("application/x-zip-compressed");
         else if(!stricmp(partfilename+strlen(partfilename)-4,".cab")
                ||!stricmp(partfilename+strlen(partfilename)-4,".dll")
                ||!stricmp(partfilename+strlen(partfilename)-4,".exe"))
            s1.send("application/octet-stream");
         else
            s1.send("text/plain",10);
         file.seekg(0,ios::end);
         char line[256];
         unsigned int l;
         wsprintf(line,"\r\nContent-Length: %u\r\n\r\n",l=(unsigned int)file.tellg());
         file.seekg(0);
         s1.send(line);
         char filebuf[2048];
         while(l){
            file.read(filebuf,int((l<2048)?l:2048U));
            s1.send(filebuf,int((l<2048)?l:2048U));
            l=(l<2048)?0:(l-2048);
         }
         DBG("SocketFn-8");
         return;
      }else if(!useprox&&strnicmp(url,"http://",7)){
         HttpError(s1,"Only \"http://\" proxy requests supported");
         DBG("SocketFn-9");
         return;
      }
   DBG("SocketFn...5");
      if(file) file.close();
   DBG("SocketFn...6");
      NewText(hwnd,url);
   DBG("SocketFn...7");
      char*ptr=url;
      while(*ptr&&*ptr!=':') ++ptr;
      if(*ptr++==':'){
         if(*ptr=='/') ++ptr;
         if(*ptr=='/') ++ptr;
         host=ptr;
         methodLen=ptr-url;
         methodStr=url;
      }else host=url;
      ptr=host;
      char c;
      char*colon=NULL;
      while((c=*ptr)&&c!='/'){
         if(c==':') colon=ptr;
         if(c=='@') colon=NULL;
         ++ptr;
      }
      if(colon){
         ptr=colon;
         c=':';
      }
      *ptr++='\0';
      if(!c) --ptr;
      if(c==':'){
         if(*ptr&&*ptr!='/'){
            port=0;
            while((c=*ptr)&&c!='/'){
               ++ptr;
               if(c<'0'||c>'9'){
                  HttpError(s1,"Invalid port");
                  DBG("SocketFn-A");
                  return;
               }
               port*=(unsigned short)10;
               port+=(unsigned short)(c-'0');
            }
         }
         if(*ptr) ++ptr;
      }
      url=ptr;

   DBG("SocketFn...8");

      if(enabled){
         if(activeFilters->matchFilters(host,url)){
            s1.send("HTTP/1.0 200 OK\r\n" //17
                    "Content-Length: 42\r\n" //20
                    "Content-Type: image/gif\r\n" //25
                    "\r\n", //2
                    64);
            s1.send(transGif,42);
            DBG("SocketFn-B");
            return;
         }
   /*
         if(!strcmp(url,"ftproot/chall/cont_idx.gif")){
            HttpError(s1,"Censored");
            return;
         }
   */
      }
      int n=strlen(url);
   DBG("SocketFn...9");
      if(n>=4&&(
         !stricmp(url+n-4,".gif")
         ||!stricmp(url+n-4,".jpg")
         ||(n>=5&&!stricmp(url+n-5,".jpeg"))
            ))
         SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);

   DBG("SocketFn...A");

      if(up) up=stricmp(host,"127.0.0.1");
      ip=up?getip(proxname):getip(host);

   DBG("SocketFn...B");

//      {
//         char msg[1024];
//         wsprintf(msg,"method=\"%s\"\n"
//                      "host=\"%s\"\n"
//                      "ip=%x\n"
//                      "url=\"%s\"\n"
//                      "port=%d",method,host,ip,url,port);
//   //      MessageBox(NULL,msg,"debug",MB_OK);
//      }

      if(ip==INADDR_NONE){
         HttpError(s1,up?"Unknown proxy host":"Unknown host",!up);
         DBG("SocketFn-C");
         return;
      }

   }


   SockSet set1; set1.add(s1);

   DBG("SocketFn...C");
   Socket s2;
   DBG("SocketFn...D");
retry0:
   if(s2.connect(secure?tunport:up?proxport:port,ip)){
      DWORD err=DWORD(WSAGetLastError());
      if(err==WSAETIMEDOUT&&autoRetry){
         if(Select(&set1,NULL,NULL).wait(0)){
            DBG("SocketFn-D");
            return;
         }
         goto retry0;
      }
      HttpError(s1,"WebMask could not connect to host",true,err);
      DBG("SocketFn-E");
      return;
   }
   DBG("SocketFn...E");


   if(secure){
      s2.send(buf,int(line.linelen()));
   }else{
      s2.send(method,int(strlen(method)));
      if(up){
         s2.send(" ",1);
         if(methodLen) s2.send(methodStr,methodLen);
         s2.send(host);
         if(port!=80){
            char str[16];
            wsprintf(str,":%u",port);
            s2.send(str);
         }
         s2.send("/",1);
      }
      else s2.send(" /",2);
      s2.send(url);
   }
   DBG("SocketFn...F");

   if(httphi&&!secure){
      s2.send(" HTTP/1.0\r\n",11);
   }else{
      s2.send("\r\n",2);
   }
   DBG("SocketFn...10");


   SockSet set2; set2 .add(s2);
   SockSet set12;set12.add(s1);set12.add(s2);
   if(secure){
      unsigned int n=line.restlen();
      int err;
      if(n){
         err=s2.sendRaw(line.restbuf(),n);
         line.eat(n);
         if(!err||err==SOCKET_ERROR){
            DBG("SocketFn-F");
            return;
         }
         char sendbuf[BUFLEN];
         char recvbuf[BUFLEN];
         char*s0=sendbuf;
         int slen=0;
         char*r0=recvbuf;
         int rlen=0;
         for(;;){
            //if(slen) 0 2 2
            //else     1 0 1
            //if(rlen) 0 1 1
            //else     2 0 2
            Select(slen?(rlen?NULL:&set2):(rlen?&set1:&set12),
                   slen?(rlen?&set12:&set2):(rlen?&set1:NULL),
                   NULL/*slen?(rlen?&set12:&set2):(rlen?&set1:&set12)*/).wait();
            if(!slen){
               if(Select(&set1,NULL,NULL/*&set1*/).wait(0)){
                  slen=s1.recvRaw(s0=sendbuf,BUFLEN);
                  if(!slen||slen==SOCKET_ERROR){
                     DBG("SocketFn-10");
                     return;
                  }
               }
            }
            if(slen){
               if(Select(NULL,&set2,NULL/*&set2*/).wait(0)){
                  int n=s2.sendRaw(s0,slen);
                  if(!n||n==SOCKET_ERROR){
                     DBG("SocketFn-11");
                     return;
                  }
                  slen-=n;
               }
            }
            if(!rlen){
               if(Select(&set2,NULL,NULL/*&set2*/).wait(0)){
                  rlen=s2.recvRaw(r0=recvbuf,BUFLEN);
                  if(!rlen||rlen==SOCKET_ERROR){
                     DBG("SocketFn-12");
                     return;
                  }
               }
            }
            if(rlen){
               if(Select(NULL,&set1,NULL/*&set1*/).wait(0)){
                   int n=s1.sendRaw(r0,rlen);
                   if(!n||n==SOCKET_ERROR){
                     DBG("SocketFn-13");
                     return;
                  }
                   rlen-=n;
               }
            }
         }
      }
   }

   DBG("SocketFn...11");

   unsigned int content_length=0;
   BOOL via=FALSE;
   char viastr[256];
   switch(viaType){
   case genuine:
      wsprintf(viastr,"1.0 %s:%u (WebMask/"WEBMASK_VERSION_NS")",myname,myPort);
      break;
   case override:
      strcpy(viastr,viaText);
      break;
   }
   if(httphi){
      for(;;){
         line.getline();
         if(line.linelen()){
            if(strnicmp(line.linebuf(),"Proxy-Connection:",17)
               &&strnicmp(line.linebuf(),"Connection:",11))
            {
               if((!anonUserAgent||strnicmp(line.linebuf(),"User-Agent:",11))
                  &&(!anonUA||strnicmp(line.linebuf(),"UA-",3))
                  &&(!anonReferer||strnicmp(line.linebuf(),"Referer:",8))
                  &&(!anonFrom||strnicmp(line.linebuf(),"From:",5))){
//               if(!anon||(strnicmp(line.linebuf(),"User-Agent:",11)
//                          &&strnicmp(line.linebuf(),"UA-",3))
//                          &&strnicmp(line.linebuf(),"Referer:",8)
//                          &&strnicmp(line.linebuf(),"From:",5)){
                  s2.send(buf=line.linebuf(),int(line.linelen()));
                  if(viaType!=noVia&&!strnicmp(line.linebuf(),"Via:",4)){
                     via=TRUE;
                     s2.send(", ",2);
                     s2.send(viastr);
                  }else if(!strnicmp(line.linebuf(),"Content-Length:",15)){
                     char*ptr=line.linebuf()+15;
                     for(unsigned int i=line.linelen()-15;i;--i){
                        if(*ptr>='0'&&*ptr<='9'){
                           content_length*=10U;
                           content_length+=(unsigned int)(*ptr-'0');
                        }
                        ++ptr;
                     }
                  }
                  s2.send("\r\n",2);
               }
            }
         }else break;
      }
   }
   if(nocache){
      s2.send("Pragma: no-cache\r\nCache-control: max-age=0\r\n",44);
   }
   if(viaType!=noVia&&!via){
      s2.send("Via: ",5);
      s2.send(viastr);
      s2.send("\r\n\r\n",4);
   }else
      s2.send("\r\n",2);

   DBG("SocketFn...12");

   if(content_length){
//      char msg[256];
//      wsprintf(msg,"content_length=%u",content_length);
//      MessageBox(NULL,msg,"WebMask",MB_OK);
//      int err;
      unsigned int n=line.restlen();
      if(n>=content_length){
         /*err=*/s2.send(line.restbuf(),content_length);
//         wsprintf(msg,"send(%d)=%d",content_length,err);
//         MessageBox(NULL,msg,"WebMask",MB_OK);
         /*err=*/line.restbuf()/*[content_length]*/;
//         line.restbuf()[content_length]='\0';
//         MessageBox(NULL,line.restbuf(),"WebMask buf",MB_OK);
//         line.restbuf()[content_length]=err;
         line.eat(content_length);
      }else{
         /*err=*/s2.send(line.restbuf(),n);
//         wsprintf(msg,"send(%d)=%d",n,err);
//         MessageBox(NULL,msg,"WebMask",MB_OK);
         line.eat(n);
         content_length-=n;
         char buf[BUFLEN];
         while(content_length){
            int n=s1.recvRaw(buf,int(content_length>BUFLEN?BUFLEN:content_length));
            if(!n||n==SOCKET_ERROR){
               abort=TRUE;
               break;
            }else{
               /*err=*/s2.send(buf,n);
//               wsprintf(msg,"send(%d)=%d",n,err);
//               MessageBox(NULL,msg,"WebMask",MB_OK);
            }
            content_length-=(unsigned int)n;
         }
      }
   }

   DBG("SocketFn...13");

   if(abort)
      HttpError(s1,"Aborted");
   else{
      char resbuf[BUFLEN];
      for(;;){
         Select(&set12,NULL,NULL/*&set12*/).wait();
         if(Select(&set2,NULL,NULL/*&set2*/).wait(0)){
            int n=s2.recvRaw(resbuf,BUFLEN);
            if(!n||n==SOCKET_ERROR) break;
            n=s1.sendRaw(resbuf,n);
            if(!n||n==SOCKET_ERROR) break;
         }
         if(Select(&set1,NULL,NULL/*&set1*/).wait(0)){
            int n=s1.recvRaw(resbuf,1);
            if(!n||n==SOCKET_ERROR) break;
         }
      }
   }
   DBG("SocketFn-0");
}

BOOL MenuAddString(HMENU hMenu,char*buf,UINT id,UINT state,UINT type){
   MENUITEMINFO mii;
   mii.cbSize=sizeof(MENUITEMINFO);
   mii.fMask=MIIM_CHECKMARKS|MIIM_DATA|MIIM_ID|MIIM_STATE|MIIM_SUBMENU|MIIM_TYPE;
   mii.fType=MFT_STRING|type;
   mii.fState=state;
   mii.wID=id;
   mii.hSubMenu=NULL;
   mii.hbmpChecked=NULL;
   mii.hbmpUnchecked=NULL;
   mii.dwItemData=0;
   mii.dwTypeData=buf;
   return(InsertMenuItem(hMenu,(unsigned int)(-1),TRUE,&mii));
}

BOOL MenuAddMenu(HMENU hMenu,char*buf,HMENU hMenuChild){
   MENUITEMINFO mii;
   mii.cbSize=sizeof(MENUITEMINFO);
   mii.fMask=MIIM_CHECKMARKS|MIIM_DATA|MIIM_ID|MIIM_STATE|MIIM_SUBMENU|MIIM_TYPE;
   mii.fType=MFT_STRING;
   mii.fState=MFS_ENABLED;
   mii.wID=0;
   mii.hSubMenu=hMenuChild;
   mii.hbmpChecked=NULL;
   mii.hbmpUnchecked=NULL;
   mii.dwItemData=0;
   mii.dwTypeData=buf;
   return(InsertMenuItem(hMenu,(unsigned int)(-1),TRUE,&mii));
}

BOOL MenuAddSeparator(HMENU hMenu){
   MENUITEMINFO mii;
   mii.cbSize=sizeof(MENUITEMINFO);
   mii.fMask=MIIM_CHECKMARKS|MIIM_DATA|MIIM_ID|MIIM_STATE|MIIM_SUBMENU|MIIM_TYPE;
   mii.fType=MFT_SEPARATOR;
   mii.fState=MFS_ENABLED;
   mii.wID=0;
   mii.hSubMenu=NULL;
   mii.hbmpChecked=NULL;
   mii.hbmpUnchecked=NULL;
   mii.dwItemData=0;
   return(InsertMenuItem(hMenu,(unsigned int)(-1),TRUE,&mii));
}

void DoPopupMenu(HWND pHwnd,int x,int y){
   switch(contextMode&CM_MENUPOS_MASK){
      case CM_MENUPOS_WEBMASK:{
         POINT pt={0,0};
         ClientToScreen(hwnd,&pt);
         x=pt.x;y=pt.y;
         break;
      }
      case CM_MENUPOS_PARAMETER:{
         POINT pt={0,0};
         ClientToScreen(pHwnd,&pt);
         x=pt.x;y=pt.y;
         break;
      }
      case CM_MENUPOS_256_256:
         x=y=256;
         break;
   }
   HMENU hMenu=CreatePopupMenu();
   MenuAddString(hMenu,"WebMask &Properties...",IDM_PROPERTIES,MFS_ENABLED|MFS_DEFAULT);
   MenuAddString(hMenu,"&Enable",IDM_ENABLE,MFS_ENABLED|(enabled?MFS_CHECKED:MFS_UNCHECKED));
   MenuAddSeparator(hMenu);
   MenuAddString(hMenu,"&About WebMask...",IDM_ABOUT);
   MenuAddString(hMenu,"WebMask &Help",IDM_HELP);
   MenuAddSeparator(hMenu);
   MenuAddString(hMenu,"&Close",IDM_CLOSE);

   HWND f;
   if(contextMode&CM_POSTFOCUS_SAVE) f=GetFocus();

   switch(contextMode&CM_PREFOCUS_MASK){
   case CM_PREFOCUS_PARAM:
      if(contextMode&CM_PREPOPUP_FGD) SetForegroundWindow(pHwnd);
      else SetFocus(pHwnd);
      break;
   case CM_PREFOCUS_GLOBAL:
      if(contextMode&CM_PREPOPUP_FGD) SetForegroundWindow(hwnd);
      else SetFocus(hwnd);
      break;
   case CM_PREFOCUS_NONE:
      break;
   case CM_PREFOCUS_NULL:
      if(contextMode&CM_PREPOPUP_FGD) SetForegroundWindow(NULL);
      else SetFocus(NULL);
      break;
   }

   if(!((contextMode&CM_TRACK_NOEX)?
      TrackPopupMenu(hMenu,TPM_LEFTALIGN|TPM_RIGHTBUTTON,x,y,0,hwnd,NULL):
      TrackPopupMenuEx(hMenu,TPM_LEFTALIGN|TPM_RIGHTBUTTON,x,y,hwnd,NULL))
   ){
      char msg[80];
      wsprintf(msg,"menu error=0x%x",GetLastError());
      MessageBox(NULL,msg,"WebMask",MB_OK);
   }

   if(contextMode&CM_POSTPOPUP_NULL) PostMessage(hwnd,WM_NULL,0,0);

   if(contextMode&4){
      if(contextMode&CM_PREPOPUP_FGD) SetForegroundWindow(f);
      else SetFocus(f);
   }

   DestroyMenu(hMenu);
}

void WebMask_OnRButtonDown(HWND hwnd,BOOL,int x,int y,UINT){
   if((contextMode&CM_MENUON_MASK)==CM_MENUON_RDOWN){
      POINT pt={x,y};
      ClientToScreen(hwnd,&pt);
      DoPopupMenu(hwnd,pt.x,pt.y);
   }
}
void WebMask_OnRButtonUp(HWND hwnd,int x,int y,UINT){
   if((contextMode&CM_MENUON_MASK)==CM_MENUON_RUP){
      POINT pt={x,y};
      ClientToScreen(hwnd,&pt);
      DoPopupMenu(hwnd,pt.x,pt.y);
   }
}
void WebMask_OnContextMenu(HWND hwnd,HWND clickHwnd,int x,int y){
   if((contextMode&CM_MENUON_CX_MASK)){
      POINT pt={x,y};
      DoPopupMenu((contextMode&(CM_MENUON_CX_CLICK&~CM_MENUON_CX_MASK))?clickHwnd:hwnd,pt.x,pt.y);
   }
}

void Enable(BOOL e){
   enabled=e;
   ConnectCount::show();
//   strcpy(nid.szTip,enabled?"WebMask enabled":"WebMask disabled");
//   Shell_NotifyIcon(NIM_MODIFY,&nid);
}

extern HWND generalWnd;

void WebMask_OnCommand(HWND hwnd,int id,HWND,UINT){
   switch(id){
   case IDM_PROPERTIES:
      Properties(hwnd);
      break;
   case IDM_ENABLE:
      Enable(!enabled);
      if(hPropWnd&&generalWnd/*&&!canApply*/){
         PropSheet_Changed(hPropWnd,generalWnd);
//         PostMessage(hPropWnd,PSM_CHANGED,0,0);
//         canApply=TRUE;
//         PropEnable();
      }
      break;
   case IDM_CLOSE:
      DestroyWindow(hwnd);
      break;
   case IDM_ABOUT:
      MessageBox(hwnd,"WebMask version "WEBMASK_VERSION,"WebMask",
                 MB_ICONINFORMATION|MB_OK);
      break;
   case IDM_HELP:
      DialogPage::LoadPage("webmask.html");
      break;
   }
}

void WebMask_OnTrayMouse(HWND hwnd,UINT msg,UINT){
   if(msg==WM_RBUTTONUP){
      POINT pt;
      if(contextMode&CM_CURPOS_MESSAGE){
         DWORD pos=GetMessagePos();
         pt.x=LOWORD(pos);
         pt.y=HIWORD(pos);
      }else{
         GetCursorPos(&pt);
      }
      switch(contextMode&CM_TRAYTYPE_MASK){
      case CM_TRAYTYPE_RDOWN:
         ScreenToClient(hwnd,&pt);
         if(contextMode&CM_TRAYMSG_SEND)
            FORWARD_WM_RBUTTONDOWN(hwnd,0,pt.x,pt.y,0,SendMessage);
         else
            FORWARD_WM_RBUTTONDOWN(hwnd,0,pt.x,pt.y,0,PostMessage);
         break;
      case CM_TRAYTYPE_RUP:
         ScreenToClient(hwnd,&pt);
         if(contextMode&CM_TRAYMSG_SEND)
            FORWARD_WM_RBUTTONUP(hwnd,pt.x,pt.y,0,SendMessage);
         else
            FORWARD_WM_RBUTTONUP(hwnd,pt.x,pt.y,0,PostMessage);
         break;
      case CM_TRAYTYPE_CONTEXT:
         if(contextMode&CM_TRAYMSG_SEND)
            FORWARD_WM_CONTEXTMENU(hwnd,hwnd,pt.x,pt.y,SendMessage);
         else
            FORWARD_WM_CONTEXTMENU(hwnd,hwnd,pt.x,pt.y,PostMessage);
         break;
      case CM_TRAYTYPE_SELF:
         DoPopupMenu(hwnd,pt.x,pt.y);
         break;
      }

   }else if(msg==WM_LBUTTONDBLCLK){
      Properties(hwnd);
   }
}

void WebMask_OnLButtonDown(HWND hwnd,BOOL d,int,int,UINT){
   if(d) Properties(hwnd);
}

LRESULT CALLBACK WindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam){
   switch(msg){
      HANDLE_MSG(hwnd,WM_CREATE,          WebMask_OnCreate);
      HANDLE_MSG(hwnd,WM_PAINT,           WebMask_OnPaint);
      HANDLE_MSG(hwnd,WM_DESTROY,         WebMask_OnDestroy);
      HANDLE_MSG(hwnd,WM_RBUTTONDOWN,     WebMask_OnRButtonDown);
      HANDLE_MSG(hwnd,WM_RBUTTONUP,       WebMask_OnRButtonUp);
      HANDLE_MSG(hwnd,WM_CONTEXTMENU,     WebMask_OnContextMenu);
      HANDLE_MSG(hwnd,WM_LBUTTONDBLCLK,   WebMask_OnLButtonDown);
      HANDLE_MSG(hwnd,WM_COMMAND,         WebMask_OnCommand);
      HANDLE_MSG(hwnd,WM_TRAY_MOUSE,      WebMask_OnTrayMouse);
      HANDLE_MSG(hwnd,WM_TIMER,           WebMask_OnTimer);
      HANDLE_MSG(hwnd,WM_SIZE,            WebMask_OnSize);
   }
   return(DefWindowProc(hwnd,msg,wParam,lParam));
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
                   LPSTR cmdLine,int nCmdShow){
   MSG msg;
   WNDCLASSEX wc;

   GetModuleFileName(NULL,gfullfilename,1024);
   char*ptr=gfullfilename;
   char c;
   while(c=*ptr++){
      if((c=='/'||c==':'||c=='\\')&&*ptr) gpartfilename=ptr;
   }

   hInst=hInstance;

   if(!hPrevInstance){
      wc.cbSize=sizeof(WNDCLASSEX);
      wc.style=CS_VREDRAW|CS_DBLCLKS;
      wc.hInstance=hInstance;
      wc.lpfnWndProc=(WNDPROC)WindowProc;
      wc.cbClsExtra=0;
      wc.cbWndExtra=0;
      wc.hIcon=LoadIcon(hInstance,MAKEINTRESOURCE(ICON_LARGE));
      wc.hCursor=LoadCursor(NULL,IDC_ARROW);
      wc.hbrBackground=(HBRUSH)(1+COLOR_BTNFACE);
      wc.lpszMenuName=NULL;
      wc.lpszClassName=APPNAME;
      wc.hIconSm=LoadIcon(hInstance,MAKEINTRESOURCE(ICON_SMALL));
      RegisterClassEx(&wc);
   }

   hIconBusy=LoadIcon(hInstance,MAKEINTRESOURCE(ICON_BUSY));
   hIconIdle=LoadIcon(hInstance,MAKEINTRESOURCE(ICON_SMALL));
   hIconStall=LoadIcon(hInstance,MAKEINTRESOURCE(ICON_STALL));
   {
      WinSock winSock;
      if(!winSock) return(1);

//      calcIP();

      gethostname(myname,1024);
      mynamelen=int(strlen(myname));


      PrefLoad();
      enabled=startEnabled;

      DWORD cmdCM=0;
      sscanf(cmdLine,"%8x",&cmdCM);
      contextMode|=cmdCM;

      int x=200,y=200;
      int w=300,h=50;
      if(contextMode&CM_LOADSTART_YES){
         HKEY hkey;
         if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\PseudoFoo\\WebMask",0,
                         KEY_READ,&hkey)==ERROR_SUCCESS){
            LoadRegNumDef(hkey,"window x",x,x);
            LoadRegNumDef(hkey,"window y",y,y);
            LoadRegNumDef(hkey,"window w",w,w);
            LoadRegNumDef(hkey,"window h",h,h);
            RegCloseKey(hkey);
         }
      }

DBG("0");

      hwnd=CreateWindowEx(
         WS_EX_CONTROLPARENT
            |((contextMode&CM_ZORDER_TOPMOST)?WS_EX_TOPMOST:0)
            |((contextMode&CM_WINTYPE_TOOL)?WS_EX_TOOLWINDOW:0),
         APPNAME,
         "WebMask",
         WS_OVERLAPPEDWINDOW,
         x,y,
         w,h,
         NULL,
         NULL,
         hInstance,
         NULL);

DBG("1");

      ShowWindow(hwnd,(contextMode&CM_MAINWIN_SHOW)?nCmdShow:SW_HIDE);
      if(contextMode&CM_MAINWIN_SHOW){
         InvalidateRect(hwnd,NULL,TRUE);
         UpdateWindow(hwnd);
      }

      nid.cbSize=sizeof(NOTIFYICONDATA);
      nid.hWnd=hwnd;
      nid.uID=ICON_LARGE;
      nid.uFlags=NIF_ICON|NIF_MESSAGE|NIF_TIP;
      nid.uCallbackMessage=WM_TRAY_MOUSE;
      nid.hIcon=hIconIdle;
      strcpy(nid.szTip,"");
      Shell_NotifyIcon(NIM_ADD,&nid);
      SetWindowText(hwnd,nid.szTip);
DBG("2");
      Enable(startEnabled);

DBG("3");

      while(GetMessage(&msg,NULL,0,0)){
         TranslateMessage(&msg);
         DispatchMessage(&msg);
      }

      delete(activeFilters);
      activeFilters=NULL;

   }

   Shell_NotifyIcon(NIM_DELETE,&nid);
   if(hIconBusy) DestroyIcon(hIconBusy);
   if(hIconIdle) DestroyIcon(hIconIdle);
   if(hIconStall) DestroyIcon(hIconStall);

   return(int(msg.wParam));
}

void NewContextMode(){
   ShowWindow(hwnd,SW_HIDE);
   UpdateWindow(hwnd);
   SetWindowLong(hwnd,GWL_EXSTYLE,
      WS_EX_CONTROLPARENT
         |((contextMode&CM_ZORDER_TOPMOST)?WS_EX_TOPMOST:0)
         |((contextMode&CM_WINTYPE_TOOL)?WS_EX_TOOLWINDOW:0));
   SetWindowPos(hwnd,(contextMode&CM_ZORDER_TOPMOST)?HWND_TOPMOST:HWND_NOTOPMOST,
      0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_DRAWFRAME|SWP_FRAMECHANGED|
         ((contextMode&CM_MAINWIN_SHOW)?SWP_SHOWWINDOW:SWP_HIDEWINDOW));

//   ShowWindow(hwnd,(contextMode&CM_MAINWIN_SHOW)?SW_SHOW:SW_HIDE);
   if(contextMode&CM_MAINWIN_SHOW){
      InvalidateRect(hwnd,NULL,TRUE);
      UpdateWindow(hwnd);
   }
}
