#ifndef WEBMASK_H
#define WEBMASK_H

#define WM_SOCKET_SELECT (WM_USER+0x100)
#define HANDLE_WM_SOCKET_SELECT(hwnd,wParam,lParam,fn) \
   ((fn)((hwnd),(SOCKET)(wParam),WSAGETSELECTERROR(lParam),WSAGETSELECTEVENT(lParam)),0L)
#define FORWARD_WM_SOCKET_SELECT(hwnd,socket,error,event,fn) \
   (void)(fn)((hwnd),WM_SOCKET_SELECT,(WPARAM)(socket),(LPARAM)WSAMAKESELECTREPLY(event,error))

#define WM_TRAY_MOUSE (WM_USER+0x101)
#define HANDLE_WM_TRAY_MOUSE(hwnd,wParam,lParam,fn) \
   ((fn)((hwnd),(UINT)(lParam),(UINT)(wParam)),0L)
#define FORWARD_WM_TRAY_MOUSE(hwnd,msg,id,fn) \
   (void)(fn)((hwnd),WM_TRAY_MOUSE,(WPARAM)(id),(LPARAM)(msg))

#ifndef HANDLE_WM_HELP
#define HANDLE_WM_HELP(hwnd,wParam,lParam,fn) \
   ((fn)((hwnd),(HELPINFO*)(lParam)),1L)
#define FORWARD_WM_HELP(hwnd,lphi,fn) \
   (void)(fn)((hwnd),WM_HELP,0,(LPARAM)(lphi))
#endif

/*
#define HANDLE_WM_CONTEXTMENU(hwnd,wParam,lParam,fn) \
   ((fn)((hwnd),(HWND)(wParam),LOWORD(lParam),HIWORD(lParam)),0L)
#define FORWARD_WM_CONTEXTMENU(hwnd,hItemHandle,x,y,fn) \
   (void)(fn)((hwnd),WM_CONTEXTMENU,(WPARAM)(hItemHandle),MAKELPARAM(x,y))
*/

#ifndef HANDLE_WM_CONTEXTMENU
#define HANDLE_WM_CONTEXTMENU(hwnd, wParam, lParam, fn) \
    ((fn)((hwnd), (HWND)(wParam), (UINT)LOWORD(lParam), (UINT)HIWORD(lParam)), 0L)
#define FORWARD_WM_CONTEXTMENU(hwnd, hwndContext, xPos, yPos, fn) \
    (void)(fn)((hwnd), WM_CONTEXTMENU, (WPARAM)(HWND)(hwndContext), MAKELPARAM((UINT)(xPos), (UINT)(yPos)))
#endif


#define APPNAME "WebMask"

#define WEBMASK_VERSION "0.3 beta"
#define WEBMASK_VERSION_NS "0.3beta"

#define BUFLEN 8192

extern HINSTANCE hInst;
extern DWORD contextMode;
extern DWORD autoRetry;
//extern SOCKET listenSocket;
extern BOOL enabled;
extern BOOL startEnabled;
extern BOOL useprox;
extern BOOL usetun;
extern char proxname[256];
extern unsigned long proxip;
extern unsigned short proxport;
extern char tunname[256];
extern unsigned short tunport;
extern unsigned long tunip;
extern unsigned short myPort;
//extern BOOL anon;
extern BOOL anonUserAgent;
extern BOOL anonUA;
extern BOOL anonReferer;
extern BOOL anonFrom;
extern enum ViaType{genuine=0,override=1,noVia=2} viaType;
extern char viaText[256];
extern BOOL nocache;
extern BOOL gopherImages;
extern BOOL useLocal;
extern char localPath[256];

extern char myname[1024];
extern int mynamelen;

extern char filterFile[256];

inline bool LoadRegString(HKEY hkey,char*key,char*str,DWORD keylen){
   return(hkey&&RegQueryValueEx(hkey,key,NULL,NULL,(BYTE*)str,&keylen)==ERROR_SUCCESS);
}
inline bool LoadRegDword(HKEY hkey,char*key,DWORD&var){
   DWORD keylen=sizeof(DWORD);
   return(hkey&&RegQueryValueEx(hkey,key,NULL,NULL,(BYTE*)&var,&keylen)==ERROR_SUCCESS);
}
template <class T> inline bool LoadRegNum(HKEY hkey,char*key,T&var){
   DWORD d=DWORD(var);
   if(LoadRegDword(hkey,key,d)){
      var=(T)d;
      return(true);
   }
   return(false);
}

inline void LoadRegDwordDef(HKEY hkey,char*key,DWORD&var,DWORD def){
   if(!LoadRegDword(hkey,key,var)) var=def;
}
inline void LoadRegStringDef(HKEY hkey,char*key,char*str,DWORD keylen,char*def){
   if(!LoadRegString(hkey,key,str,keylen)) strcpy(str,def);
}
template <class T>inline void LoadRegNumDef(HKEY hkey,char*key,T&var,T def){
   if(!LoadRegNum(hkey,key,var)) var=def;
}

inline void SaveRegDword(HKEY hkey,char*key,DWORD var){
   if(hkey) RegSetValueEx(hkey,key,0,REG_DWORD,(BYTE*)&var,sizeof(DWORD));
}
inline void SaveRegString(HKEY hkey,char*key,char*str){
   DWORD len=1+strlen(str);
   if(hkey) RegSetValueEx(hkey,key,0,REG_SZ,(BYTE*)str,len);
}
template <class T> inline void SaveRegNum(HKEY hkey,char*key,T var){
   DWORD d=DWORD(var);
   if(hkey) RegSetValueEx(hkey,key,0,REG_DWORD,(BYTE*)&d,sizeof(DWORD));
}


BOOL MenuAddString(HMENU hMenu,char*buf,UINT id=0,UINT state=MFS_ENABLED,UINT type=0);
BOOL MenuAddMenu(HMENU hMenu,char*buf,HMENU hMenuChild);
BOOL MenuAddSeparator(HMENU hMenu);

class Filter{
   void operator=(const Filter&);
public:
   char*name;

   enum PathType{EXACT,PARTIAL} pathType;
   char*exact;
   char*start;
   char*end;

   Filter*next;
   Filter*prev;

   int num;

//   Filter():name(NULL),
//      pathType(EXACT),exact(NULL),start(NULL),end(NULL),
//      next(NULL),prev(NULL),num(-1){}

   Filter(const Filter&f):name(NULL),
      pathType(f.pathType),exact(NULL),start(NULL),end(NULL),
      next(NULL),prev(NULL),num(-1)
   {
      name =new char[f.name ?1+strlen(f.name ):1];strcpy(name ,f.name ?f.name :"");
      exact=new char[f.exact?1+strlen(f.exact):1];strcpy(exact,f.exact?f.exact:"");
      start=new char[f.start?1+strlen(f.start):1];strcpy(start,f.start?f.start:"");
      end  =new char[f.end  ?1+strlen(f.end  ):1];strcpy(end  ,f.end  ?f.end  :"");
   }

   Filter(const char*name,
      PathType pathType,const char*exact,const char*start,const char*end,
      Filter*next=NULL)
   :
      name(NULL),
      pathType(pathType),exact(NULL),start(NULL),end(NULL),
      next(next),prev(NULL),num(-1)
   {
      this->name =new char[name ?1+strlen(name ):1];strcpy(this->name ,name ?name :"");
      this->exact=new char[exact?1+strlen(exact):1];strcpy(this->exact,exact?exact:"");
      this->start=new char[start?1+strlen(start):1];strcpy(this->start,start?start:"");
      this->end  =new char[end  ?1+strlen(end  ):1];strcpy(this->end  ,end  ?end  :"");
      if(next) next->prev=this;
   }

   Filter(const char*name,unsigned int namelen,
      PathType pathType,
      const char*exact,unsigned int exactlen,const char*start,unsigned int startlen,
      const char*end,unsigned int endlen,
      Filter*next=NULL)
   :
      name(NULL),
      pathType(pathType),exact(NULL),start(NULL),end(NULL),
      next(next),prev(NULL),num(-1)
   {
      this->name =new char[1+namelen ];strncpy(this->name ,name ,namelen );this->name [namelen ]='\0';
      this->exact=new char[1+exactlen];strncpy(this->exact,exact,exactlen);this->exact[exactlen]='\0';
      this->start=new char[1+startlen];strncpy(this->start,start,startlen);this->start[startlen]='\0';
      this->end  =new char[1+endlen  ];strncpy(this->end  ,end  ,endlen  );this->end  [endlen  ]='\0';
      if(next) next->prev=this;
   }

   ~Filter(){
      delete[](name);
      delete[](exact);
      delete[](start);
      delete[](end);
      if(next) next->prev=prev;
      if(prev) prev->next=next;
   }
};

class FilterList{
   void operator=(const FilterList&);
public:
   Filter*f;
   FilterList():f(NULL){}
   ~FilterList();
   BOOL matchFilters(char*name,char*url);

   void add(const char*name,Filter::PathType pathType,
            const char*exact,const char*start,const char*end){
      f=new Filter(name,pathType,exact,start,end,f);
   }
   void add(const char*name,unsigned int namelen,Filter::PathType pathType,
            const char*exact,unsigned int exactlen,const char*start,unsigned int startlen,
            const char*end,unsigned int endlen){
      f=new Filter(name,namelen,pathType,
                   exact,exactlen,start,startlen,end,endlen,f);
   }
   FilterList(const FilterList&l);

   void clearNum();
   void setNum(Filter*filter,int n);
   void delNum(int n);
};

extern FilterList*activeFilters;

void calcIP();
class ConnectCount{
public:
   static unsigned long n;
   static void show();
   ConnectCount(){InterlockedIncrement((long*)&n);ConnectCount::show();};
   ~ConnectCount(){InterlockedDecrement((long*)&n);ConnectCount::show();};
};

void NewContextMode();

bool startListening();

#endif
