#define STRICT
#include <windows.h>
#include <windowsx.h>
#pragma hdrstop

#include <iostream.h>
#include <fstream.h>

#include "sock.h"

int recvCount=0;
int sendCount=0;

int WinSock::count=0;
WSADATA WinSock::wsaData;

int Socket::recv(char*buf,int maxlen){
   if(closed()) return(0);
   int len=0;
   while(len<maxlen){
      int n=::recv(s,buf+len,maxlen-len,0);
      if(!n||n==SOCKET_ERROR){
         closed_=true;
         return(len);
      }
      len+=n;
   }
   return(len);
}

int Socket::send(char*buf,int maxlen){
   if(closed()) return(0);
   int len=0;
   while(len<maxlen){
      int n=::send(s,buf+len,maxlen-len,0);
      if(!n||n==SOCKET_ERROR){
         closed_=true;
         return(len);
      }
      len+=n;
   }
   return(len);
}

void SockSet::add(const Socket&s){FD_SET(s.s,&fds);}
void SockSet::del(const Socket&s){FD_CLR(s.s,&fds);}


int Select::wait(timeval*t,bool setres){
   if(setres){
      return(select(0,&r->fds,&w->fds,&e->fds,t));
   }else{
      FD_SET rr;if(r) rr=r->fds;
      FD_SET ww;if(w) ww=w->fds;
      FD_SET ee;if(e) ee=e->fds;
      return(select(0,r?&rr:NULL,w?&ww:NULL,e?&ee:NULL,t));
   }
}
